package utep.plmr;

import java.awt.*;
import java.awt.event.*;
//import java.awt.geom.Point2D;
import java.io.*;
import java.net.URL;
import java.util.*;

import javax.swing.*;
import javax.swing.event.*;

import org.jfree.chart.*;
import org.jfree.chart.labels.StandardXYZToolTipGenerator;
import org.jfree.chart.plot.*;
import org.jfree.chart.renderer.xy.*;
import org.jfree.chart.renderer.category.*;
import org.jfree.chart.urls.*;
import org.jfree.data.category.*;
import org.jfree.data.general.*;
import org.jfree.data.xy.*;
import org.jfree.chart.axis.*;

import org.jgraph.*;
import org.jgraph.graph.*;

import utep.plmr.jfree.XYZSeries;
import utep.plmr.jfree.XYZSeriesCollection;
import utep.plmr.jfree.myLASRenderer;
import utep.plmr.jfree.myXYPlot;

import utep.plmr.server.*;

/**
 * MainWindow of PWHN client
 * @author derDoc
 *
 */
public class MainWindow {

	// the frame of the window
	public static JFrame			myFrame;

	// some defs, #def should really work in Java

	public static final float		GRPH_BACKGR_SCALE		= 8;

	public static final int			GRAPH_FONT_S			= 2;

	// the panels for the tabs
	static final JPanel				IPPanel					= new JPanel(
																	new BorderLayout());

	static final JPanel				InitPanel				= new JPanel(
																	new BorderLayout());

	static final JPanel				UpdaPanel				= new JPanel(
																	new BorderLayout());

	static final JPanel				EvalPanel				= new JPanel(
																	new BorderLayout());

	static final JPanel				ResPanel				= new JPanel(
																	new BorderLayout());

	// vars for IP (1)
	static JPanel					jp1						= new JPanel();

	static JPanel					jp1b					= new JPanel();

	static JLabel					jl1						= new JLabel(
																	"File/URL");

	static final JTextField			jt1						= new JTextField(20);

	static final JTextArea			jta1					= new JTextArea(
																	20,
																	20);

	static final JButton			jb1a					= new JButton(
																	"Run!");

	static final JButton			jb1b					= new JButton(
																	"Sync");

	static final JButton			jb1						= new JButton(
																	"Browse/Go");

	static JScrollPane				jsp1;

	static final JTextField			jt1a					= new JTextField(
																	"Username");

	static final JComboBox			jcc						= new JComboBox(
																	new String[] {
			"Flat: script", "Flat: native", "Tree: FP-FTT", "Tree: FP-KMR",
			"Tree: CO-KMR"											});

	static final JCheckBox			jcb						= new JCheckBox();

	static final JProgressBar		jpb						= new JProgressBar(
																	0,
																	100);

	static final JTextField			jt1b					= new JTextField(
																	"Name");

	static final JSlider			jsl1					= new JSlider(1, 51);

	// vars for Init (2)
	static JPanel					jp2						= new JPanel();

	static JLabel					jl2						= new JLabel(
																	"File/Dir to sync");

	static final JCheckBox			jcb2					= new JCheckBox();

	static final JTextArea			jta2					= new JTextArea(
																	20,
																	20);

	static final JTextField			jt2						= new JTextField(20);

	static JScrollPane				jsp2;

	static final JPanel				JCenterPanel2			= new JPanel(
																	new BorderLayout());

	static final JPanel				JListPane2				= new JPanel();

	static final DefaultListModel	listmodel2				= new DefaultListModel();

	static final JList				jlist2					= new JList(
																	listmodel2);

	static final JScrollPane		listScroller2			= new JScrollPane(
																	jlist2);

	static final JLabel				jSelLabel2				= new JLabel("");

	static final JButton			jb2						= new JButton(
																	"Browse/Go");

	// vars for Agg (3)
	static final JTextField			jt3						= new JTextField(20);

	static final JButton			jb3						= new JButton(
																	"Browse/Go");

	static JPanel					jp3						= new JPanel();

	static JLabel					jl3						= new JLabel(
																	"File to sync");

	static final JTextArea			jta3					= new JTextArea(
																	20,
																	20);

	static JScrollPane				jsp3;

	static final JPanel				JCenterPanel3			= new JPanel(
																	new BorderLayout());

	static final JPanel				JListPane3				= new JPanel();

	static final DefaultListModel	listmodel3				= new DefaultListModel();

	static final JList				jlist3					= new JList(
																	listmodel3);

	static final JScrollPane		listScroller3			= new JScrollPane(
																	jlist3);

	static final JLabel				jSelLabel3				= new JLabel("");

	// vars for Eval (4)
	static final JTextField			jt4						= new JTextField(20);

	static final JButton			jb4						= new JButton(
																	"Browse/Go");

	static JPanel					jp4						= new JPanel();

	static JLabel					jl4						= new JLabel("File");

	static final JTextArea			jta4					= new JTextArea(
																	20,
																	20);

	static JScrollPane				jsp4;

	static final JPanel				JCenterPanel4			= new JPanel(
																	new BorderLayout());

	static final JPanel				JListPane4				= new JPanel();

	static final DefaultListModel	listmodel4				= new DefaultListModel();

	static final JList				jlist4					= new JList(
																	listmodel4);

	static final JScrollPane		listScroller4			= new JScrollPane(
																	jlist4);

	static final JLabel				jSelLabel4				= new JLabel("");

	// vars for Results (5)
	static final JTextArea			jta5					= new JTextArea(
																	20,
																	20);

	static JScrollPane				jsp5;

	public static final ChartPanel	Res_chartPanel			= new ChartPanel(
																	null,
																	true);

	public static JFreeChart		Res_chart;

	//graph thingies 

	static JGraph					Res_graph;

	static JScrollPane				Res_graph_pane;

	static double					Res_graph_zoom;

	static final double				RES_GRAPH_SCALE_STEP	= 1;

	//static AttributeMap 				DefGraphArrowStyle;

	static Dataset					Res_dataSet;											// the currently used dataset

	static final JPanel				jp5						= new JPanel(
																	new BorderLayout());

	static final String[]			Charts					= { "--Results--",
			"(X,Y):Bar", "(X,Y):Line", "(X,Y):Dots", "(X,Y):Area",
			"(X,Y,Z):Dots-Size", "(X,Y,Z):Dots-Color", "(Name,Y):Bar",
			"(Name,Y):Line", "(Name,Y):Area", "--Paths--", "delay vs. size",
			"2d-World links", "plain Tree", "Left-Tree"	};

	static final JComboBox			jcc5					= new JComboBox(
																	Charts);

	static JButton					jb_chartprefs			= new JButton(
																	"Chart Prefs");

	static JPanel					jp_res_north			= new JPanel();

	static JTable					Res_RunTable;

	static JScrollPane				Res_RunScrollPane;

	// end vars section

	
	/**
	 * creates the window
	 */
	public MainWindow() {
		makeWindow();
	}

	/**
	 * makes the window, all fields and buttons and the like...
	 *
	 */
	private static void makeWindow() {

		myFrame = new JFrame("PWHN beta 1.0");
		myFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		myFrame.setSize(610, 410);

		// make content
		makeMenus();
		makeIPPanel();
		makeInitPanel();
		makeAggPanel();
		makeEvalPanel();
		makeResPanel();

		/** main tabbed panel * */
		// make the tabbed Pane
		JTabbedPane jtp = new JTabbedPane();
		jtp.addTab("Servers", null, IPPanel, "Select servers");
		jtp.addTab("Gen", null, InitPanel, "Gen script");
		jtp.addTab("Agg", null, UpdaPanel, "Aggregation script");
		jtp.addTab("Eval", null, EvalPanel, "Eval script");
		jtp.addTab("Result", null, ResPanel, "Results");

		myFrame.getContentPane().add(jtp);
		myFrame.pack();
		myFrame.setVisible(true);

	}

	/**
	 * creates menus
	 *
	 */
	private static void makeMenus() {

		// create Menubar
		JMenuBar menuBar = new JMenuBar();

		/** File menu **/
		JMenu FileMenu = new JMenu("File");
		FileMenu.setMnemonic(KeyEvent.VK_F);
		//load proj
		JMenuItem menuItemLoad = new JMenuItem(
				"Load Project from file...",
				KeyEvent.VK_L);
		menuItemLoad.setAccelerator(KeyStroke.getKeyStroke(
				KeyEvent.VK_O,
				ActionEvent.META_MASK));
		menuItemLoad.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				Project p = pwhn.cP.LoadFromFile();
				if (p != null) {
					pwhn.cP = p;
					pwhn.cP.Res_Content.atm = pwhn.cP.Res_Content.new myTableModel();
					updateWndFields();
					ChartPrefs.UpdatePrefs(p.chart_pref);
				}
			}
		});
		FileMenu.add(menuItemLoad);
		//store proj
		JMenuItem menuItemStore = new JMenuItem(
				"Save Project as...",
				KeyEvent.VK_S);
		menuItemStore.setAccelerator(KeyStroke.getKeyStroke(
				KeyEvent.VK_S,
				ActionEvent.META_MASK));
		FileMenu.add(menuItemStore);
		menuItemStore.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				pwhn.cP.SaveToFile();
			}
		});
		//FileMenu.add(new JSeparator());

		/** Runs **/
		JMenu EditMenu = new JMenu("Runs");
		EditMenu.setMnemonic(KeyEvent.VK_R);

		//del run
		JMenuItem menuItemDelRun = new JMenuItem(
				"Delete selected Run",
				KeyEvent.VK_D);
		menuItemDelRun.setAccelerator(KeyStroke.getKeyStroke(
				KeyEvent.VK_D,
				ActionEvent.META_MASK));
		menuItemDelRun.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				if (-1 != Res_RunTable.getSelectedRow())
					pwhn.cP.Res_Content.delRun(Res_RunTable.getSelectedRow());
			}
		});
		EditMenu.add(menuItemDelRun);

		//store runs in DB
		JMenuItem menuItemStoreDB = new JMenuItem("Store in DB", KeyEvent.VK_S);
		menuItemStoreDB.setEnabled(false);
		// menuItemDelRun.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,
		// ActionEvent.META_MASK));
		menuItemStoreDB.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {}
		});
		EditMenu.add(menuItemStoreDB);

		//load runs from DB
		JMenuItem menuItemLoadDB = new JMenuItem("Load from DB", KeyEvent.VK_L);
		menuItemLoadDB.setEnabled(false);
		// menuItemDelRun.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,
		// ActionEvent.META_MASK));
		menuItemLoadDB.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {}
		});
		EditMenu.add(menuItemLoadDB);

		//xchange series and cat.
		JMenuItem menuItemXChart = new JMenuItem(
				"XChange series<->category",
				KeyEvent.VK_X);
		menuItemXChart.setAccelerator(KeyStroke.getKeyStroke(
				KeyEvent.VK_X,
				ActionEvent.META_MASK));
		menuItemXChart.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				if (pwhn.cP.Res_Method == 0
						|| (Res_dataSet instanceof DefaultCategoryDataset)) {
					pwhn.cP.Res_Content.XChangeSerCat();
					updateChart();
				}
			}
		});
		EditMenu.add(menuItemXChart);

		//save run as text file...
		JMenuItem menuItemSaveRun = new JMenuItem(
				"Save selected Run as...",
				KeyEvent.VK_R);
		menuItemSaveRun.setAccelerator(KeyStroke.getKeyStroke(
				KeyEvent.VK_R,
				ActionEvent.META_MASK));
		menuItemSaveRun.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				if (-1 != Res_RunTable.getSelectedRow()) {
					JFileChooser jfc = new JFileChooser(System
							.getProperty("user.dir"));
					jfc.setFileSelectionMode(JFileChooser.FILES_ONLY);
					jfc.setMultiSelectionEnabled(false);
					if (JFileChooser.APPROVE_OPTION == jfc.showSaveDialog(null)) {
						try {
							BufferedWriter bfw = new BufferedWriter(
									new FileWriter(jfc.getSelectedFile()));
							String d = pwhn.cP.Res_Content.getRun(Res_RunTable
									.getSelectedRow()).Data;
							bfw.write(d + "\n");
							bfw.close();
						} catch (Exception ex) {
							ex.printStackTrace();
						}
					}
				}
			}
		});
		EditMenu.add(menuItemSaveRun);

		/** Chart menu **/
		JMenu ChartMenu = new JMenu("Chart");
		ChartMenu.setMnemonic(KeyEvent.VK_C);
		//		save chart as...
		JMenuItem menuItemSave = new JMenuItem("Save pic as...", KeyEvent.VK_P);
		menuItemSave.setAccelerator(KeyStroke.getKeyStroke(
				KeyEvent.VK_P,
				ActionEvent.META_MASK));
		menuItemSave.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				try {
					//chart if <10, graph otherwise
					if (jcc5.getSelectedIndex() < 12)
						Res_chartPanel.doSaveAs();
					else if (jcc5.getSelectedIndex() > 11)
						pwhn.SaveGraphAs(Res_graph);

				} catch (Exception ex) {
					ex.printStackTrace();
				}
			}
		});
		ChartMenu.add(menuItemSave);

		//reset zoom
		JMenuItem menuItemResChart = new JMenuItem("reset Zoom", KeyEvent.VK_Z);
		menuItemResChart.setAccelerator(KeyStroke.getKeyStroke(
				KeyEvent.VK_Z,
				ActionEvent.META_MASK));
		menuItemResChart.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				ChartPrefs cp = pwhn.cP.chart_pref;
				if (pwhn.cP.Res_Method == 0 || pwhn.cP.Res_Method == 10
						|| pwhn.cP.Res_Method > 11)
					return;
				else if (pwhn.cP.Res_Method < 7 || pwhn.cP.Res_Method > 10) {
					XYPlot xy = (XYPlot) Res_chart.getPlot();
					ValueAxis va = xy.getDomainAxis();
					va.setLowerBound(cp.X_Min);
					va.setUpperBound(cp.X_Max);
					va = xy.getRangeAxis();
					va.setLowerBound(cp.Y_Min);
					va.setUpperBound(cp.Y_Max);
				} else {
					CategoryPlot xy = (CategoryPlot) Res_chart.getPlot();
					ValueAxis va = xy.getRangeAxis();
					va.setLowerBound(cp.Y_Min);
					va.setUpperBound(cp.Y_Max);
				}
			}
		});
		ChartMenu.add(menuItemResChart);

		/** Graph menu **/
		JMenu GraphMenu = new JMenu("Graph");
		GraphMenu.setMnemonic(KeyEvent.VK_G);

		//zoom in
		JMenuItem menuItemInGraph = new JMenuItem("Zoom in", KeyEvent.VK_Z);

		menuItemInGraph.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				if (pwhn.cP.Res_Method < 12)
					return;
				Res_graph_zoom += RES_GRAPH_SCALE_STEP;
				Res_graph.setScale(Res_graph_zoom);

			}
		});
		GraphMenu.add(menuItemInGraph);

		//zoom out
		JMenuItem menuItemOutGraph = new JMenuItem("Zoom out", KeyEvent.VK_O);

		menuItemOutGraph.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				if (pwhn.cP.Res_Method < 12)
					return;
				Res_graph_zoom -= RES_GRAPH_SCALE_STEP;
				Res_graph.setScale(Res_graph_zoom);

			}
		});
		GraphMenu.add(menuItemOutGraph);

		/** PLMR-server menu **/
		JMenu PLMRMenu = new JMenu("PLMR-Server");
		PLMRMenu.setMnemonic(KeyEvent.VK_P);

		//sync
		JMenuItem menuItemPLMRsync = new JMenuItem(
				"Sync server files",
				KeyEvent.VK_Y);

		menuItemPLMRsync.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				JFileChooser jfc = new JFileChooser(System
						.getProperty("user.dir"));
				jfc
						.setDialogTitle("Select directory containing PLMR-server files");
				jfc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
				jfc.setMultiSelectionEnabled(false);

				if (JFileChooser.APPROVE_OPTION != jfc.showOpenDialog(null))
					return;

				//now call the syncer from the flatnative runner
				Runners.FlatNativeRunner fnr = new Runners().new FlatNativeRunner();
				fnr.setup();
				String f = jfc.getSelectedFile().getName();

				if (f.endsWith("/"))
					f = f.substring(0, f.length() - 1);

				try {
					fnr.sync(f);
				} catch (Exception ex) {
					ex.printStackTrace();
				}
				pwhn.cP.synced = false;

			}
		});
		PLMRMenu.add(menuItemPLMRsync);

		//start
		JMenuItem menuItemPLMRstart = new JMenuItem(
				"Start server",
				KeyEvent.VK_S);
		menuItemPLMRstart.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				JFileChooser jfc = new JFileChooser(System
						.getProperty("user.dir"));
				jfc
						.setDialogTitle("Select start script in PLMR-server directory");
				jfc.setFileSelectionMode(JFileChooser.FILES_ONLY);
				jfc.setMultiSelectionEnabled(false);

				if (JFileChooser.APPROVE_OPTION != jfc.showOpenDialog(null))
					return;
				//now call the execer from the flatnative runner
				Runners.FlatNativeRunner fnr = new Runners().new FlatNativeRunner();
				fnr.setup();

				//get the parent dir name
				String f = jfc.getSelectedFile().getParentFile().getName();
				//add trailing slash
				if (!f.endsWith("/"))
					f += "/";

				//get sel file itself
				String n = jfc.getSelectedFile().getName();
				//remove trailing slash
				//if (n.endsWith("/"))
				//	n = n.substring(0, n.length() - 1);
				//and append file to parent
				f += n;

				//run the script on the first server only
				//first get the list of IPs
				ArrayList Ips = new ArrayList(Arrays.asList(fnr.IPs));
				String[] firstip = new String[] { (String) Ips.remove(0) };
				fnr.IPs = firstip;
				//then run
				try {
					fnr.exec(f, -1, 0);
				} catch (Exception ex) {
					ex.printStackTrace();
				}

				//wait ..
				//wait ...
				//wait ....
				try {
					Thread.sleep(5000);
				} catch (Exception ex) {
					ex.printStackTrace();
				}

				//now! run in a loop over every 20
				fnr.IPs = (String[]) Ips.toArray(new String[0]);
				fnr.e_cmdl = firstip[0];
				//fnr.prefix_cmdline = "./";
				//and run
				try {
					fnr.exec(f, -1, 0);
				} catch (Exception ex) {
					ex.printStackTrace();
				}
				/*
				for (int i = 0; i < Ips.size() / 20; i++) {

					int end = Math.min((i+1)*20, Ips.size()-1);
					fnr.IPs = (String[]) Ips.subList(i*20, end).toArray(
							new String[0]);
					//set the commandline to the i-th server
					fnr.e_cmdl = (String) Ips.get(i);
					//fnr.prefix_cmdline = "./";
					//and run
					try {
						fnr.exec(f, -1, 0);
					} catch (Exception ex) {
						ex.printStackTrace();
					}
				}
				*/
				
				
			}
		});
		PLMRMenu.add(menuItemPLMRstart);

		//		stop
		JMenuItem menuItemPLMRstop = new JMenuItem("Stop server", KeyEvent.VK_P);
		menuItemPLMRstop.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {

				JFileChooser jfc = new JFileChooser(System
						.getProperty("user.dir"));
				jfc
						.setDialogTitle("Select stop script in PLMR-server directory");
				jfc.setFileSelectionMode(JFileChooser.FILES_ONLY);
				jfc.setMultiSelectionEnabled(false);

				if (JFileChooser.APPROVE_OPTION != jfc.showOpenDialog(null))
					return;
				//now call the execer from the flatnative runner
				Runners.FlatNativeRunner fnr = new Runners().new FlatNativeRunner();
				fnr.setup();

				String f = jfc.getSelectedFile().getParentFile().getName();
				//add trailing slash
				if (!f.endsWith("/"))
					f += "/";

				//get sel file itself
				String n = jfc.getSelectedFile().getName();
				//remove trailing slash
				//if (n.endsWith("/"))
				//	n = n.substring(0, n.length() - 1);
				//and append file to parent
				f += n;

				//run the cmd
				try {
					fnr.exec(f, -1, 0);
				} catch (Exception ex) {
					ex.printStackTrace();
				}

			}
		});
		PLMRMenu.add(menuItemPLMRstop);

		// menubar
		menuBar.add(FileMenu);
		menuBar.add(EditMenu);
		menuBar.add(ChartMenu);
		menuBar.add(GraphMenu);
		menuBar.add(PLMRMenu);
		myFrame.setJMenuBar(menuBar);

	}

	
	// helper functions to make content for tabs
	/**
	 * creates all content for the IP panel
	 */
	private static void makeIPPanel() {

		jp1.add(jl1);
		jp1.add(jt1);

		jta1.setText("#Or enter IPs here, one per line");
		jta1.getDocument().addDocumentListener(new DocumentListener() {
			public void insertUpdate(DocumentEvent e) {
				Upd();
			}

			public void removeUpdate(DocumentEvent e) {
				Upd();
			}

			public void changedUpdate(DocumentEvent e) {
				Upd();
			}

			private void Upd() {
				pwhn.cP.IP_ScriptContent = jta1.getText();
				pwhn.cP.IP_bScriptContent_dirty = true;
				pwhn.cP.synced = false;
				if (jta1.getText().length() < 1) {
					jb1a.setEnabled(false);
					jb1b.setEnabled(false);
					return;
				}
				if (jta2.getText().length() > 1
						&& !jta2.getText().equals("#Or enter script here")) {
					jb1a.setEnabled(true);
					jb1b.setEnabled(true);
				} else {
					jb1a.setEnabled(false);
					jb1b.setEnabled(false);
				}
				if (pwhn.cP.Init_FileIsDir)
					jb1b.setEnabled(true);
			}
		});

		jsp1 = new JScrollPane(
				jta1,
				JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
				JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);

		jb1.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				// check if textfield empty -> open file chooser
				if (jt1.getText().length() == 0) {
					JFileChooser jfc = new JFileChooser(System
							.getProperty("user.dir"));
					jfc.setFileSelectionMode(JFileChooser.FILES_ONLY);
					jfc.setMultiSelectionEnabled(false);
					if (JFileChooser.APPROVE_OPTION == jfc
							.showOpenDialog(myFrame)) {
						jt1.setText(jfc.getSelectedFile().getPath());
						jb1.doClick();
					}
				} else { // not empty, check contents
					// see if its a URL
					if (jt1.getText().startsWith("http")
							|| jt1.getText().startsWith("www")) {
						try {
							BufferedReader bfr = new BufferedReader(
									new InputStreamReader(
											new URL(jt1.getText()).openStream()));
							jta1.setText("");
							String line = null;
							while ((line = bfr.readLine()) != null)
								jta1.append(line + "\n");
							pwhn.cP.IP_bScriptContent_dirty = false;

						} catch (Exception ex) {
							ex.printStackTrace();
						}
					} else {
						// file
						try {
							BufferedReader bfr = new BufferedReader(
									new FileReader(new File(jt1.getText())));
							jta1.setText("");
							String line = null;
							while ((line = bfr.readLine()) != null) {
								if (!line.matches("^(\\p{Print}|\\p{Space})*$")) {
									JOptionPane
											.showMessageDialog(
													myFrame,
													"This needs to be a non-binary file!");
									jt1.setText("");
									return;
								}
								jta1.append(line + "\n");

							}
							pwhn.cP.IP_bScriptContent_dirty = false;
						} catch (Exception ex) {
							ex.printStackTrace();
						}
					}
					// and save
					pwhn.cP.IP_File = jt1.getText();
					pwhn.cP.synced = false;

				}
			}
		});
		jp1.add(jb1);
		IPPanel.add(jp1, BorderLayout.NORTH);
		IPPanel.add(jsp1, BorderLayout.CENTER);

		// user field
		jt1a.getDocument().addDocumentListener(new DocumentListener() {
			public void insertUpdate(DocumentEvent e) {
				pwhn.cP.IP_Username = jt1a.getText();
			}

			public void removeUpdate(DocumentEvent e) {
				pwhn.cP.IP_Username = jt1a.getText();
			}

			public void changedUpdate(DocumentEvent e) {
				pwhn.cP.IP_Username = jt1a.getText();
			}
		});
		// combobox
		jcc.setSelectedIndex(0);
		jcc.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				pwhn.cP.IP_Method = jcc.getSelectedIndex();
			}
		});

		//checkbox
		jcb.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				pwhn.cP.IP_bCollPI = jcb.isSelected();
			}
		});

		jcb.setSelected(true);
		JPanel jp1c = new JPanel();
		jp1c.add(new JLabel("Collect PathInfo: "));
		jp1c.add(jcb);

		// make panel for all 3 and add
		JPanel jp1d = new JPanel(new BorderLayout());
		jp1d.add(jt1a, BorderLayout.NORTH);
		jp1d.add(jcc, BorderLayout.CENTER);
		jp1d.add(jp1c, BorderLayout.SOUTH);

		// slider
		jsl1.setMajorTickSpacing(10);
		jsl1.setMinorTickSpacing(1);
		jsl1.setPaintTicks(true);
		jsl1.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				pwhn.cP.IP_Threads = jsl1.getValue();
			}
		});
		// set initial value in Project
		pwhn.cP.IP_Threads = jsl1.getValue();
		JPanel jp1e1 = new JPanel();
		jp1e1.add(new JLabel("#Threads:"));
		jp1e1.add(jsl1);

		// progressbar
		jpb.setValue(0);
		jpb.setStringPainted(false);
		// jpb.setPreferredSize(new Dimension(400,20));

		JPanel jp1e = new JPanel(new BorderLayout());
		jp1e.add(jp1e1, BorderLayout.NORTH);
		jp1e.add(jpb, BorderLayout.SOUTH);

		// buttons
		// Sync button
		jb1b.setEnabled(false);
		jb1b.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				if (jb1b.getText().equals("Sync")) {
					jb1b.setText("stop");
					pwhn.go(jpb, null);
				} else {
					pwhn.stop();
					jb1b.setText("Sync");
				}
			}
		});

		// Run! button
		jb1a.setEnabled(false);
		jb1a.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				if (jb1a.getText().equals("Run!")) {
					jb1a.setText("stop");
					pwhn.go(jpb, jt1b.getText());
				} else {
					pwhn.stop();
					jb1a.setText("Run!");
				}
			}
		});
		JPanel jp1f1 = new JPanel();
		// and panel for run button and name field
		jp1f1.add(jb1a);
		jp1f1.add(new JLabel("as:"));
		jp1f1.add(jt1b);

		// panel for buttons
		JPanel jp1f = new JPanel(new BorderLayout());
		jp1f.add(jb1b, BorderLayout.NORTH);
		jp1f.add(jp1f1, BorderLayout.SOUTH);

		// add all to Panel
		jp1b.add(jp1d);
		jp1b.add(jp1e);
		jp1b.add(jp1f);

		// and add to box
		IPPanel.add(jp1b, BorderLayout.SOUTH);

	}

	/**
	 * creates content for Init Panel
	 *
	 */
	private static void makeInitPanel() {

		jp2.add(jl2);
		jp2.add(jt2);
		//browse go button
		jp2.add(jb2);

		jp2.add(new JLabel("3-in1 "));
		jcb2.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				pwhn.cP.Init_File3in1 = jcb2.isSelected();
				if (jcb2.isSelected()) {
					UpdaPanel.setEnabled(false);
					EvalPanel.setEnabled(false);
				} else {
					UpdaPanel.setEnabled(true);
					EvalPanel.setEnabled(true);
				}
			}
		});

		jcb2.setSelected(false);
		jp2.add(jcb2);

		// the textarea
		jta2.setText("#Or enter script here");
		jta2.getDocument().addDocumentListener(new DocumentListener() {
			public void insertUpdate(DocumentEvent e) {
				Upd();
			}

			public void removeUpdate(DocumentEvent e) {
				Upd();
			}

			public void changedUpdate(DocumentEvent e) {
				Upd();
			}

			private void Upd() {
				if (jta1.getText().length() > 1
						&& !jta1.getText().equals(
								"#Or enter IPs here, one per line")) {
					jb1a.setEnabled(true);
					jb1b.setEnabled(true);
				} else {
					jb1a.setEnabled(false);
					jb1b.setEnabled(false);

				}
				pwhn.cP.Init_bScriptContent_dirty = true;
				pwhn.cP.synced = false;
			}
		});

		jsp2 = new JScrollPane(
				jta2,
				JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
				JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);

		// make a list in case user selected a dir to sync
		jlist2.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		jlist2.setLayoutOrientation(JList.HORIZONTAL_WRAP);
		jlist2.setVisibleRowCount(10);
		listScroller2.setPreferredSize(new Dimension(250, 60));
		jlist2.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				if (e.getValueIsAdjusting() == false) {

					if (jlist2.getSelectedIndex() == -1) {
						jb1a.setEnabled(false);
					} else {
						// Selection
						pwhn.cP.Init_FileInDir = (String) jlist2
								.getSelectedValue();
						if (jta1.getText().length() > 1)
							jb1a.setEnabled(true);

						byte[] bites = null;
						try {
							File f = new File(jt2.getText() + '/'
									+ (String) jlist2.getSelectedValue());

							FileInputStream bfr = new FileInputStream(f);
							bites = new byte[(int) f.length()];
							bfr.read(bites);

						} catch (Exception ex) {
							ex.printStackTrace();
						}

						jta2.setText("");
						String t = new String(bites);

						try {

							String ts[] = t.split("\n");
							int h = 0;
							for (h = 0; h < ts.length; h++) {
								if (!ts[h]
										.matches("^(\\p{Print}|\\p{Space})*$")) {
									jta2.setText("<binary File>");
									break;
								}
							}
							if (h == ts.length)
								jta2.setText(t);

						} catch (Throwable ex) {
							System.out.println("Throwable while regexing:");
							ex.printStackTrace();
						}

						pwhn.cP.Init_bScriptContent_dirty = false;
						pwhn.cP.synced = false;
						pwhn.cP.Init_ScriptContent = bites;

					}
				}
			}
		});
		//
		JListPane2.add(jSelLabel2);
		JListPane2.add(listScroller2);
		//

		jb2.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				// check if textfield empty -> open file chooser
				if (jt2.getText().length() == 0) {
					JFileChooser jfc = new JFileChooser(System
							.getProperty("user.dir"));
					jfc
							.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
					jfc.setMultiSelectionEnabled(false);
					if (JFileChooser.APPROVE_OPTION == jfc
							.showOpenDialog(myFrame)) {
						jt2.setText(jfc.getSelectedFile().getPath());
						jb2.doClick();
					}

				} else { // not empty, check contents
					// get file
					try {
						File f = new File(jt2.getText());
						if (f.isFile()) {
							jSelLabel2.setText("");
							FileInputStream bfr = new FileInputStream(f);
							byte[] bites = new byte[(int) f.length()];
							bfr.read(bites);

							jta2.setText("");
							String t = new String(bites);

							String ts[] = t.split("\n");
							int h = 0;
							for (h = 0; h < ts.length; h++) {
								if (!ts[h]
										.matches("^(\\p{Print}|\\p{Space})*$")) {
									jta2.setText("<binary File>");
									break;
								}
							}
							if (h == ts.length)
								jta2.setText(t);

							pwhn.cP.Init_bScriptContent_dirty = false;
							pwhn.cP.Init_ScriptContent = bites;
							JCenterPanel2.remove(JListPane2);
							pwhn.cP.Init_FileIsDir = false;
						} else {// dir
							jSelLabel2.setText("Select Init File:");
							File files[] = f.listFiles();
							listmodel2.clear();
							for (int i = 0; i < files.length; i++)
								if (files[i].isFile())
									listmodel2.addElement(files[i].getName());

							JCenterPanel2.add(JListPane2, BorderLayout.NORTH);
							pwhn.cP.Init_FileIsDir = true;
							jt3.setText(jt2.getText());
							jt4.setText(jt2.getText());
							jb3.doClick();
							jb4.doClick();
							if (jta1.getText().length() > 1
									&& !jta1.getText().equals(
											"#Or enter IPs here, one per line")) {
								jb1b.setEnabled(true);
							}
						}
					} catch (Exception ex) {
						ex.printStackTrace();
					}
					pwhn.cP.Init_File = jt2.getText();
					pwhn.cP.synced = false;
					myFrame.repaint();
				}
			}
		});

		InitPanel.add(jp2, BorderLayout.NORTH);
		JCenterPanel2.add(jsp2, BorderLayout.CENTER);
		InitPanel.add(JCenterPanel2, BorderLayout.CENTER);
	}

	/** 
	 * content for Agg panel
	 *
	 */
	private static void makeAggPanel() {

		jp3.add(jl3);
		jp3.add(jt3);
		// the textarea
		jta3.setText("#Or enter script here");
		jta3.getDocument().addDocumentListener(new DocumentListener() {
			public void insertUpdate(DocumentEvent e) {
				upd();
			}

			public void removeUpdate(DocumentEvent e) {
				upd();
			}

			public void changedUpdate(DocumentEvent e) {
				upd();
			}

			private void upd() {
				pwhn.cP.Upd_ScriptContent = jta3.getText().getBytes();
				pwhn.cP.Upd_bScriptContent_dirty = true;
				pwhn.cP.synced = false;
			}
		});

		jsp3 = new JScrollPane(
				jta3,
				JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
				JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);

		// make a list in case user selected a dir to sync

		jlist3.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		jlist3.setLayoutOrientation(JList.HORIZONTAL_WRAP);
		jlist3.setVisibleRowCount(10);
		listScroller3.setPreferredSize(new Dimension(250, 60));
		jlist3.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				if (e.getValueIsAdjusting() == false) {

					if (jlist3.getSelectedIndex() == -1) {
						// No selection, disable fire button.
					} else {
						// Selection
						pwhn.cP.Upd_FileInDir = (String) jlist3
								.getSelectedValue();
						byte[] bites = null;

						try {
							File f = new File(jt3.getText() + '/'
									+ (String) jlist3.getSelectedValue());

							FileInputStream bfr = new FileInputStream(f);
							bites = new byte[(int) f.length()];
							bfr.read(bites);

						} catch (Exception ex) {
							ex.printStackTrace();
						}

						jta3.setText("");
						String t = new String(bites);

						try {
							String ts[] = t.split("\n");
							int h = 0;
							for (h = 0; h < ts.length; h++) {
								if (!ts[h]
										.matches("^(\\p{Print}|\\p{Space})*$")) {
									jta3.setText("<binary File>");
									break;
								}
							}
							if (h == ts.length)
								jta3.setText(t);

						} catch (Throwable ex) {
							System.out.println("Throwable while regexing:");
							ex.printStackTrace();
						}

						pwhn.cP.Upd_ScriptContent = bites;
						pwhn.cP.synced = false;

						pwhn.cP.Upd_bScriptContent_dirty = false;

					}
				}
			}
		});

		//
		JListPane3.add(jSelLabel3);
		JListPane3.add(listScroller3);
		//
		jb3.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				// check if textfield empty -> open file chooser
				if (jt3.getText().length() == 0) {
					JFileChooser jfc = new JFileChooser(System
							.getProperty("user.dir"));
					jfc.setFileSelectionMode(JFileChooser.FILES_ONLY);
					jfc.setMultiSelectionEnabled(false);
					if (JFileChooser.APPROVE_OPTION == jfc
							.showOpenDialog(myFrame)) {

						jt3.setText(jfc.getSelectedFile().getPath());
						jb3.doClick();
					}

				} else { // not empty, check contents
					// get file
					try {
						File f = new File(jt3.getText());
						if (f.isFile()) {
							jSelLabel3.setText("");
							FileInputStream bfr = new FileInputStream(f);
							byte[] bites = new byte[(int) f.length()];
							bfr.read(bites);

							jta3.setText("");
							String t = new String(bites);

							String ts[] = t.split("\n");
							int h = 0;
							for (h = 0; h < ts.length; h++) {
								if (!ts[h]
										.matches("^(\\p{Print}|\\p{Space})*$")) {
									jta3.setText("<binary File>");
									break;
								}
							}
							if (h == ts.length)
								jta3.setText(t);

							pwhn.cP.Upd_ScriptContent = bites;
							pwhn.cP.synced = false;

							pwhn.cP.Upd_bScriptContent_dirty = false;
							JCenterPanel3.remove(JListPane3);

						} else {// dir
							jSelLabel3.setText("Select Update file:");
							File files[] = f.listFiles();
							listmodel3.clear();
							for (int i = 0; i < files.length; i++)
								if (files[i].isFile())
									listmodel3.addElement(files[i].getName());

							JCenterPanel3.add(JListPane3, BorderLayout.NORTH);

						}
					} catch (Exception ex) {
						ex.printStackTrace();
					}
					myFrame.repaint();
					pwhn.cP.Upd_File = jt3.getText();
				}
			}
		});
		jp3.add(jb3);
		UpdaPanel.add(jp3, BorderLayout.NORTH);
		// UpdaPanel.add(jSelLabel3, BorderLayout.WEST);
		// UpdaPanel.add(jsp3, BorderLayout.CENTER);
		JCenterPanel3.add(jsp3, BorderLayout.CENTER);
		UpdaPanel.add(JCenterPanel3, BorderLayout.CENTER);
	}

	/**
	 * Content for Eval Panel
	 *
	 */
	private static void makeEvalPanel() {

		jp4.add(jl4);
		jp4.add(jt4);
		// the textarea
		jta4.setText("#Or enter script here");
		jta4.getDocument().addDocumentListener(new DocumentListener() {
			public void insertUpdate(DocumentEvent e) {
				upd();
			}

			public void removeUpdate(DocumentEvent e) {
				upd();
			}

			public void changedUpdate(DocumentEvent e) {
				upd();
			}

			private void upd() {
				pwhn.cP.Eval_ScriptContent = jta4.getText().getBytes();
				pwhn.cP.Eval_bScriptContent_dirty = true;
				pwhn.cP.synced = false;
			}
		});
		jsp4 = new JScrollPane(
				jta4,
				JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
				JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);

		// make a list in case user selected a dir to sync

		jlist4.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		jlist4.setLayoutOrientation(JList.HORIZONTAL_WRAP);
		jlist4.setVisibleRowCount(10);
		listScroller4.setPreferredSize(new Dimension(250, 60));
		jlist4.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				if (e.getValueIsAdjusting() == false) {

					if (jlist4.getSelectedIndex() == -1) {
						// No selection, disable fire button.
					} else {
						// Selection
						pwhn.cP.Eval_FileInDir = (String) jlist4
								.getSelectedValue();
						byte[] bites = null;
						try {
							File f = new File(jt4.getText() + '/'
									+ (String) jlist4.getSelectedValue());

							FileInputStream bfr = new FileInputStream(f);
							bites = new byte[(int) f.length()];
							bfr.read(bites);
						} catch (Exception ex) {
							ex.printStackTrace();
						}
						jta4.setText("");
						String t = new String(bites);

						try {
							String ts[] = t.split("\n");
							int h = 0;
							for (h = 0; h < ts.length; h++) {
								if (!ts[h]
										.matches("^(\\p{Print}|\\p{Space})*$")) {
									jta4.setText("<binary File>");
									break;
								}
							}
							if (h == ts.length)
								jta4.setText(t);

						} catch (Throwable ex) {
							System.out.println("Throwable while regexing:");
							ex.printStackTrace();
						}

						pwhn.cP.Eval_ScriptContent = bites;
						pwhn.cP.synced = false;
						pwhn.cP.Eval_bScriptContent_dirty = false;

					}
				}
			}
		});

		//
		JListPane4.add(jSelLabel4);
		JListPane4.add(listScroller4);
		//
		jb4.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				// check if textfield empty -> open file chooser
				if (jt4.getText().length() == 0) {
					JFileChooser jfc = new JFileChooser(System
							.getProperty("user.dir"));
					jfc.setFileSelectionMode(JFileChooser.FILES_ONLY);
					jfc.setMultiSelectionEnabled(false);
					if (JFileChooser.APPROVE_OPTION == jfc
							.showOpenDialog(myFrame)) {
						jt4.setText(jfc.getSelectedFile().getPath());
						jb4.doClick();
					}

				} else { // not empty, check contents
					// get file
					try {
						File f = new File(jt4.getText());
						if (f.isFile()) {
							jSelLabel4.setText("");

							FileInputStream bfr = new FileInputStream(f);
							byte[] bites = new byte[(int) f.length()];
							bfr.read(bites);

							jta4.setText("");
							String t = new String(bites);

							String ts[] = t.split("\n");
							int h = 0;
							for (h = 0; h < ts.length; h++) {
								if (!ts[h]
										.matches("^(\\p{Print}|\\p{Space})*$")) {
									jta4.setText("<binary File>");
									break;
								}
							}
							if (h == ts.length)
								jta4.setText(t);

							pwhn.cP.Eval_ScriptContent = bites;
							pwhn.cP.synced = false;
							pwhn.cP.Eval_bScriptContent_dirty = false;
							JCenterPanel4.remove(JListPane4);

						} else {// dir
							jSelLabel4.setText("Select eval file:");
							File files[] = f.listFiles();
							listmodel4.clear();
							for (int i = 0; i < files.length; i++)
								if (files[i].isFile())
									listmodel4.addElement(files[i].getName());

							JCenterPanel4.add(JListPane4, BorderLayout.NORTH);
						}
					} catch (Exception ex) {
						ex.printStackTrace();
					}

					pwhn.cP.Eval_File = jt4.getText();
					myFrame.repaint();
				}
			}
		});
		jp4.add(jb4);
		EvalPanel.add(jp4, BorderLayout.NORTH);
		// EvalPanel.add(jSelLabel4, BorderLayout.WEST);
		// EvalPanel.add(jsp4, BorderLayout.CENTER);
		JCenterPanel4.add(jsp4, BorderLayout.CENTER);
		EvalPanel.add(JCenterPanel4, BorderLayout.CENTER);

	}

	/** 
	 * Res Panel Content
	 *
	 */
	private static void makeResPanel() {

		jsp5 = new JScrollPane(
				jta5,
				JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
				JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);

		jcc5.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				int sel = jcc5.getSelectedIndex();
				pwhn.cP.Res_Method = sel;
				// add textarea if plain
				if (sel == 0 || sel == 10) {
					try {
						jp5.remove(jsp5);
						jp5.remove(Res_chartPanel);
						jp5.remove(Res_graph_pane);
					} catch (Exception ex) {
						//ex.printStackTrace();
					}

					jp5.add(jsp5, BorderLayout.CENTER);
					updateChart();

				} else if (sel >= 12) { //graphs
					try {
						jp5.remove(Res_chartPanel);
						jp5.remove(jsp5);
						jp5.remove(Res_graph_pane);
					} catch (Exception exc) {
						//exc.printStackTrace();
					}

					GraphModel gm = new DefaultGraphModel();

					Res_graph = new JGraph(gm);
					Res_graph.setEditable(false);
					Res_graph.setEnabled(false);

					Res_graph_pane = new JScrollPane(Res_graph);

					if (sel == 12) {
						Res_graph.setBackgroundScaled(true);

						Image ii = Toolkit.getDefaultToolkit().getImage(
								"worldmap.png").getScaledInstance(
								(int) (360 * GRPH_BACKGR_SCALE),
								(int) (180 * GRPH_BACKGR_SCALE),
								0);
						Res_graph.setBackgroundImage(new ImageIcon(ii));
					}

					jp5.add(Res_graph_pane);
					updateChart();

				} else if (sel > 0) { // or create the chart
					try {
						jp5.remove(Res_chartPanel);
						jp5.remove(jsp5);
						jp5.remove(Res_graph_pane);
					} catch (Exception ex) {
						//ex.printStackTrace();
					}

					createChart(sel);
					jp5.add(Res_chartPanel, BorderLayout.CENTER);
				}
			}
		});
		jcc5.setSelectedIndex(0);

		// create text area for plain output, and scroll pane
		jta5.setEditable(false);
		jb_chartprefs.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				ChartPrefs.show_prefs(true);
			}
		});

		jp_res_north.add(jcc5);
		jp_res_north.add(jb_chartprefs);
		jp5.add(jp_res_north, BorderLayout.NORTH);
		jp5.add(jsp5, BorderLayout.CENTER);

		// make run table, which has RunCollection.atm as its model
		Res_RunTable = new JTable(pwhn.cP.Res_Content.atm);
		Res_RunTable.getColumn("Name").setPreferredWidth(200);
		Res_RunTable.getColumn("type").setPreferredWidth(35);
		Res_RunTable.getColumn("show").setPreferredWidth(20);
		Res_RunTable.getColumn("color").setPreferredWidth(20);
		Res_RunTable.setDefaultRenderer(Color.class, new ColorRenderer(true));

		Res_RunScrollPane = new JScrollPane(Res_RunTable);
		Res_RunTable.setPreferredScrollableViewportSize(new Dimension(300, 50));
		Res_RunTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		jp5.add(Res_RunScrollPane, BorderLayout.SOUTH);

		ResPanel.add(jp5, BorderLayout.CENTER);

	}

	/**
	 * Updates all fields in the window from the main Project
	 *
	 */
	public static void updateWndFields() {

		jta1.setText(pwhn.cP.IP_ScriptContent);
		jt1.setText(pwhn.cP.IP_File);
		jt1a.setText(pwhn.cP.IP_Username);
		jcc.setSelectedIndex(pwhn.cP.IP_Method);
		jsl1.setValue(pwhn.cP.IP_Threads);
		jcb.setSelected(pwhn.cP.IP_bCollPI);

		jta2.setText(new String(pwhn.cP.Init_ScriptContent));
		jt2.setText(pwhn.cP.Init_File);
		if ((pwhn.cP.Init_File != null) && !pwhn.cP.Init_File.equals(""))
			jb2.doClick();
		jlist2.setSelectedValue(pwhn.cP.Init_FileInDir, true);

		jta3.setText(new String(pwhn.cP.Upd_ScriptContent));
		jlist3.setSelectedValue(pwhn.cP.Upd_FileInDir, true);
		jt3.setText(pwhn.cP.Upd_File);

		jta4.setText(new String(pwhn.cP.Eval_ScriptContent));
		jlist4.setSelectedValue(pwhn.cP.Eval_FileInDir, true);
		jt3.setText(pwhn.cP.Eval_File);

		jcc5.setSelectedIndex(pwhn.cP.Res_Method);
		Res_RunTable.setModel(pwhn.cP.Res_Content.atm);
		Res_RunTable.getColumn("Name").setPreferredWidth(200);

		pwhn.cP.IP_bScriptContent_dirty = false;
		pwhn.cP.Init_bScriptContent_dirty = false;
		pwhn.cP.Eval_bScriptContent_dirty = false;
		pwhn.cP.Upd_bScriptContent_dirty = false;

	}

	/**
	 * creates a chart, calls helper in Charting
	 * @param iType
	 * 				Type to create, as given in the type combobox
	 */
	public static void createChart(int iType) {
		 
		Object[] ret_arr = Charting.createChart(iType, Res_dataSet, Res_chart, Res_chartPanel);
		
		Res_chartPanel.setChart((JFreeChart)ret_arr[0]);
		Res_dataSet = (Dataset)ret_arr[1]; 
		Res_chart = (JFreeChart)ret_arr[0];
		updateChart();
	}

	/**
	 * Updates the Chart from the current runs in the Projects class
	 * calls helper in Charting
	 *
	 */
	public static void updateChart() {
		Charting.updateChart(myFrame, Res_dataSet, Res_chart, Res_chartPanel, jta5, Res_graph);
	}

	

}
