package utep.plmr;

import java.io.*;
import java.net.*;
import javax.swing.*;
import utep.plmr.server.*;

/**
 * Class that stores everything there is to PWHN
 * Runs, Options, content.. everything !
 * @author  derDoc
 */
public final class Project implements Serializable {

	private static final long	serialVersionUID	= 31071980L;

	//the chartPrefs, if any
	public ChartPrefs			chart_pref			= new ChartPrefs();

	//if this project is in sync with its list of servers
	public volatile boolean		synced;

	// IP panel vars
	public String				IP_File				= "";

	public String				IP_ScriptContent	= "";

	public boolean				IP_bScriptContent_dirty;

	public String				IP_Username			= "";

	public int					IP_Method;

	public int					IP_Threads;

	public boolean				IP_bCollPI			= true;

	// Init panel vars
	public String				Init_File			= "";

	public boolean				Init_FileIsDir;
	
	public boolean				Init_File3in1;

	public String				Init_FileInDir		= "";

	public byte[]				Init_ScriptContent	= new byte[0];

	public boolean				Init_bScriptContent_dirty;

	// Upd
	public String				Upd_File			= "";

	public String				Upd_FileInDir		= "";

	public byte[]				Upd_ScriptContent	= new byte[0];

	public boolean				Upd_bScriptContent_dirty;

	// Eval
	public String				Eval_File			= "";

	public String				Eval_FileInDir		= "";

	public byte[]				Eval_ScriptContent	= new byte[0];

	public boolean				Eval_bScriptContent_dirty;

	// Eval
	public int					Res_Method;

	//the results of the runs, RunCollection
	public RunCollection		Res_Content			= new RunCollection();

	/**
	 * creates a Project
	 * Now's the time to add some example data
	 *
	 */
	public Project() {
		/* 
		 
		 Res_Content.addRun("run0", "(utep_1,20,1.2)\n" + "(utep_2,6,4.5)\n"
		 + "(princeton1,18,0.5)\n" + "(princeton2,2,6.19)", 4l, 0, 4, 4);

		 Res_Content.addRun(
		 "run1",
		 "(utep_1,65,6.2)\n" + "(utep_2,65,2.8)\n"
		 + "(princeton1,56,10.49)\n" + "(princeton2,44,8.5)",
		 20l,
		 0,
		 4,
		 4);
*/		 
		 Res_Content.addRun("run0", "(20,1.2)\n" + "(6,4.5)\n"
		 + "(18,0.5)\n" + "(2,6.19)", 4l, 0, 4, 4);

		 Res_Content.addRun(
		 "run1",
		 "(65,6.2)\n" + "(65,2.8)\n"
		 + "(56,10.49)\n" + "(44,8.5)",
		 20l,
		 0,
		 4,
		 4);
/*
		 Res_Content.addRun("run0", "(125.45,20.32,1.2)\n" + "(-100,-5.6,4.5)\n"
		 + "(23.54,-18,0.5)\n" + "(-160.54,-2,6.19)", 4l, 0, 4, 4);

		 Res_Content.addRun(
		 "run1",
		 "(178.679,-65.43,6.2)\n" + "(-67.87,23.54,2.8)\n"
		 + "(1.056,56.34,10.49)\n" + "(-10.45,-44.43,8.5)",
		 20l,
		 0,
		 4,
		 4);
		 
		Res_Content.addRun(
				"run0",
				"(planetlab1.utep.edu,4.82)\n"
				+ "(planetlab1.chin.internet2.planet-lab.org,3.29)\n"
				+ "(planetlab2.cs.nagoya.edu.jp,5.82)\n",
				14000l,
				2,
				2,
				2);
		try {
			PathInfo c1 = new PathInfo(
					InetAddress.getByAddress(
							"planetlab1.chin.internet2.planet-lab.org",
							new byte[] { (byte) 198, (byte) 32, (byte) 154,
									(byte) 178 }),
					null,
					new PathInfo[0],
					1158522455847l,
					1,
					"41.0085",
					"-87.0065",
					48,
					88);

			PathInfo c2 = new PathInfo(
					InetAddress.getByAddress(
							"planetlab2.cs.nagoya.edu.jp",
							new byte[] { (byte) 124, (byte) 32, (byte) 154,
									(byte) 14 }),
					null,
					new PathInfo[0],
					1158522455843l,
					1,
					"34.082",
					"140.063",
					34,
					120);

			PathInfo pi = new PathInfo(
					InetAddress.getByAddress("planetlab1.utep.edu", new byte[] {
							(byte) 129, (byte) 108, (byte) 202, (byte) 10 }),
					null,
					new PathInfo[] { c1, c2 },
					1158522464961l,
					3,
					"31.75",
					"-106.49",
					77,
					0);

			Res_Content.addPathInfo(0, pi);

		} catch (Exception ex) {}
		//add the same run again
		
		Res_Content.addRun(
				"run1",
				"(planetlab1.utep.edu,4.82)\n"
				+ "(planetlab1.chin.internet2.planet-lab.org,3.29)\n"
				+ "(planetlab2.cs.nagoya.edu.jp,5.82)\n",
				14000l,
				2,
				2,
				2);
		try {
			PathInfo c1 = new PathInfo(
					InetAddress.getByAddress(
							"planetlab1.chin.internet2.planet-lab.org",
							new byte[] { (byte) 198, (byte) 32, (byte) 154,
									(byte) 178 }),
					null,
					new PathInfo[0],
					1158522455847l,
					1,
					"41.0085",
					"-87.0065",
					48,
					88);

			PathInfo c2 = new PathInfo(
					InetAddress.getByAddress(
							"planetlab2.cs.nagoya.edu.jp",
							new byte[] { (byte) 124, (byte) 32, (byte) 154,
									(byte) 14 }),
					null,
					new PathInfo[0],
					1158522455843l,
					1,
					"34.082",
					"140.063",
					34,
					120);

			PathInfo pi = new PathInfo(
					InetAddress.getByAddress("planetlab1.utep.edu", new byte[] {
							(byte) 129, (byte) 108, (byte) 202, (byte) 10 }),
					null,
					new PathInfo[] { c1, c2 },
					1158522464961l,
					3,
					"31.75",
					"-106.49",
					77,
					0);

			Res_Content.addPathInfo(1, pi);

		} catch (Exception ex) {}
*/
		
	}

	/**
	 * Opens a fileChooser, serializes and saves this instance to a file 
	 *
	 */
	public void SaveToFile() {
		JFileChooser jfc = new JFileChooser(System.getProperty("user.dir"));
		jfc.setFileSelectionMode(JFileChooser.FILES_ONLY);
		jfc.setMultiSelectionEnabled(false);
		if (JFileChooser.APPROVE_OPTION == jfc.showSaveDialog(null)) {
			try {
				ObjectOutputStream oos = new ObjectOutputStream(
						new BufferedOutputStream(new FileOutputStream(jfc
								.getSelectedFile())));
				oos.writeObject(this);
				oos.close();
			} catch (Exception ex) {
				ex.printStackTrace();
			}
		}
	}

	/**
	 * Opens a FileChooser and loads a Project from that file, deserializes it and returns it
	 * @return
	 * 			the Project loaded
	 */
	public Project LoadFromFile() {
		JFileChooser jfc = new JFileChooser(System.getProperty("user.dir"));
		jfc.setFileSelectionMode(JFileChooser.FILES_ONLY);
		jfc.setMultiSelectionEnabled(false);
		Project p = null;
		if (JFileChooser.APPROVE_OPTION == jfc.showOpenDialog(null)) {
			try {
				ObjectInputStream ois = new ObjectInputStream(
						new BufferedInputStream(new FileInputStream(jfc
								.getSelectedFile())));
				p = (Project) ois.readObject();
				ois.close();

			} catch (Exception ex) {
				ex.printStackTrace();
			}
		}
		return p;
	}

	/**
	 * returns a string represenation of this instance
	 * @return
	 *  		The String
	 */
	public String toString() {
		return new String("IP{\n" + "\tFile:" + IP_File + "\n" + "\tScript:"
				+ IP_ScriptContent + "\n" + "\tUser:" + IP_Username + "\n"
				+ "\tMethod:" + IP_Method + "\n" + "}\n" + "Init{\n"
				+ "\tFile:" + Init_File + "\n" + "\tScript:"
				+ Init_ScriptContent + "\n" + "\tDir:" + Init_FileIsDir + "\n"
				+ "\tFInDir:" + Init_FileInDir + "\n" + "}" + "Upd{\n"
				+ "\tFile:" + Upd_File + "\n" + "\tScript:" + Upd_ScriptContent
				+ "\n" + "\tFInDir:" + Upd_FileInDir + "\n" + "}" + "Eval{\n"
				+ "\tFile:" + Eval_File + "\n" + "\tScript:"
				+ Eval_ScriptContent + "\n" + "\tFInDir:" + Eval_FileInDir
				+ "\n" + "}" + "Res{\n" + "\tMeth:" + Res_Method + "\n"
				+ "\tCont:" + Res_Content + "\n" + "}");

	}

}
