package utep.plmr.jfree;

import java.util.*;

import org.jfree.data.xy.*;
import org.jfree.data.*;


/**
 * Series for XYZ Items
 * @author derDoc
 *
 */
public class XYZSeries extends XYSeries {
	
	protected List Z_data;
	
	/**
	 * Constructor
	 * @param key
	 */
	public XYZSeries(Comparable key){
		super(key);
		this.Z_data = new ArrayList();
	}
	
	/**
	 * Adds a val
	 * @param x
	 * 			X
	 * @param y
	 * 			Y
	 * @param z
	 * 			Z
	 */
	public void add(double x, double y, double z){
		super.add(x,y);
		this.Z_data.add(super.indexOf((Number)new Double(x)),new Double(z));
	}
	
	/**
	 * get a Z val
	 * @param index
	 * 			X index
	 * @return
	 * 			the Z val
	 */
	public Double getZ(int index){
		return (Double)this.Z_data.get(index);
	}
	
	/**
	 * Clears this instance
	 */
	public void clear(){
		super.clear();
		this.Z_data.clear();
	}
	
	/**
	 * Finds upper and lower bounds of Z values
	 * @return
	 * 		the bounds as a Range
	 */
	public Range findZBounds(){
		double lower = Double.MAX_VALUE;
		double upper = Double.MIN_VALUE;
		for (int i = 0; i < Z_data.size(); i++){
			if ( ((Double)this.Z_data.get(i)).doubleValue() < lower)
				lower = ((Double)this.Z_data.get(i)).doubleValue();
			if( ((Double)this.Z_data.get(i)).doubleValue() > upper)
				upper = ((Double)this.Z_data.get(i)).doubleValue();
		}
		return new Range(lower,upper);
	}
	
}
