/**
 * 
 */
package utep.plmr;

import java.io.*;
import java.util.*;
import javax.swing.*;
import org.jgraph.*;

/**
 * The main class of PWHN
 * @author  derDoc
 */
public class pwhn {

	/**main window */
	static MainWindow		wnd;

	
	static Thread			theR;

	/**runners instance */
	static Runners			r;

	static JButton			jB;

	/**project instance */
	public static Project	cP;

	/**
	 * main function
	 * @param args
	 * 			cmdline
	 */
	public static void main(String[] args) {

		new pwhn();
	}

	/**
	 * creates a PWHN instance
	 *
	 */
	public pwhn() {
		CmdExecer ce = new CmdExecer("/usr/bin/env",null,null);
		ce.bEcho = false;
		ce.run();
		if (new String(ce.stdout).indexOf("SSH_AGENT_PID") < 0)
			JOptionPane.showMessageDialog(
					MainWindow.myFrame,
					"You have no SSH-Agent running!\nThis is only advisable if your Key has en empty passphrase " +
					"(which by itself is not advisable).","No SSH Agent running", JOptionPane.WARNING_MESSAGE);
			
		//System.out.println(new String(ce.stdout));
		cP = new Project();
		wnd = new MainWindow();
	}

	/**
	 * Starts a run
	 * @param jpb
	 * 			The ProgressBar to show the progress in
	 * @param n
	 * 			name for the run
	 */
	public static void go(JProgressBar jpb, String n) {
		// check if any files changed
		if (!checkAndSaveFiles()) {
			JOptionPane.showMessageDialog(
					MainWindow.myFrame,
					"Error while trying to save Files!");
			return;
		}
		r = new Runners(MainWindow.jcc.getSelectedIndex(), jpb, n);
		r.start();
	}

	/**
	 * stops a current run
	 *
	 */
	public static void stop() {
		r.stop();
		update();
	}

	/**
	 * called after a runs finishes to give the mainWindow a chance to update
	 *
	 */
	public static void update() {
		MainWindow.updateChart();
	}

	/**
	 * called before starting a run to see if files need saving
	 * if something goes wrong, returns false and the run wont be started
	 * @return
	 * 		true - start the run
	 * 		false - some error occured
	 */
	protected static boolean checkAndSaveFiles() {
		boolean bChanged_some = false;
		if (cP.IP_bScriptContent_dirty) {
			try {
				String fname;
				BufferedWriter bfw;
				if (cP.IP_File != null && !cP.IP_File.equals(""))
					fname = cP.IP_File;
				else
					// no filename, so invent one
					fname = "IPs-" + Calendar.getInstance().getTimeInMillis();

				bfw = new BufferedWriter(new FileWriter(fname));
				bfw.write(cP.IP_ScriptContent);
				bfw.close();

				cP.IP_File = new File(fname).getAbsolutePath();
				cP.IP_bScriptContent_dirty = false;
				bChanged_some = true;
			} catch (Exception e) {
				e.printStackTrace();
				return false;
			}

		}
		if (cP.Init_bScriptContent_dirty) {

			String fname = null;
			FileOutputStream bfw;
			try {
				if (cP.Init_FileIsDir) {
					if (!("".equals(cP.Init_File)))
						fname = cP.Init_File + "/" + cP.Init_FileInDir;
					else
						// no filename, so invent one
						fname = cP.Init_File + "/" + "Init-"
								+ Calendar.getInstance().getTimeInMillis();

				} else { // no dir
					if (cP.Init_File != null && !("".equals(cP.Init_File)))
						fname = cP.Init_File;
					else { // no, and no dir, so make one
						fname = "scripts-"
								+ Calendar.getInstance().getTimeInMillis();
						File f = new File(fname);
						f.mkdir();
						cP.Init_FileIsDir = true;
						cP.Init_File = f.getAbsolutePath();
						fname = "Init-"
								+ Calendar.getInstance().getTimeInMillis();
						cP.Init_FileInDir = fname;
						fname = cP.Init_File + "/" + cP.Init_FileInDir;
					}
				}
				bfw = new FileOutputStream(fname);
				bfw.write(cP.Init_ScriptContent);
				bfw.close();

				cP.Init_bScriptContent_dirty = false;
				bChanged_some = true;
			} catch (Exception e) {
				System.out.println("fname=" + fname);
				e.printStackTrace();
				return false;
			}

		}
		if (cP.Upd_bScriptContent_dirty) {
			try {
				String fname;
				FileOutputStream bfw;
				if (cP.Init_FileIsDir) {
					if (cP.Upd_FileInDir != null
							&& !cP.Upd_FileInDir.equals(""))
						fname = cP.Init_File + "/" + cP.Upd_FileInDir;
					else
						// no filename, so invent one
						fname = cP.Init_File + "/" + "Agg-"
								+ Calendar.getInstance().getTimeInMillis();

				} else { // no dir
					if (cP.Upd_File != null && !cP.Upd_File.equals(""))
						fname = cP.Upd_File;
					else { // no script and no dir, so make one
						fname = "scripts-"
								+ Calendar.getInstance().getTimeInMillis();
						File f = new File(fname);
						f.mkdir();
						cP.Init_FileIsDir = true;
						cP.Init_File = f.getAbsolutePath();
						fname = "Agg-"
								+ Calendar.getInstance().getTimeInMillis();
						cP.Upd_FileInDir = fname;
						fname = cP.Init_File + "/" + cP.Upd_FileInDir;
					}
				}
				bfw = new FileOutputStream(fname);
				bfw.write(cP.Upd_ScriptContent);
				bfw.close();

				cP.Upd_bScriptContent_dirty = false;
				bChanged_some = true;
			} catch (Exception e) {
				e.printStackTrace();
				return false;
			}
		}

		if (cP.Eval_bScriptContent_dirty) {
			try {
				String fname;
				FileOutputStream bfw;
				if (cP.Init_FileIsDir) {
					if (cP.Eval_FileInDir != null
							&& !cP.Eval_FileInDir.equals(""))
						fname = cP.Init_File + "/" + cP.Eval_FileInDir;
					else
						// no filename, so invent one
						fname = cP.Init_File + "/" + "Eval-"
								+ Calendar.getInstance().getTimeInMillis();

				} else { // no dir
					if (cP.Eval_File != null && !cP.Eval_File.equals(""))
						fname = cP.Eval_File;
					else { // no script and no dir, so make one
						fname = "scripts-"
								+ Calendar.getInstance().getTimeInMillis();
						File f = new File(fname);
						f.mkdir();
						cP.Init_FileIsDir = true;
						cP.Init_File = f.getAbsolutePath();
						fname = "Eval-"
								+ Calendar.getInstance().getTimeInMillis();
						cP.Eval_FileInDir = fname;
						fname = cP.Init_File + "/" + cP.Eval_FileInDir;
					}
				}
				bfw = new FileOutputStream(fname);
				bfw.write(cP.Eval_ScriptContent);
				bfw.close();

				cP.Eval_bScriptContent_dirty = false;
				bChanged_some = true;
			} catch (Exception e) {
				e.printStackTrace();
				return false;
			}
		}
		if (bChanged_some)
			MainWindow.updateWndFields();
		return true;
	}

	/**
	 * Saves the Graph in a file as a pic
	 * @param g
	 * 			The graph to save
	 */
	public static void SaveGraphAs(JGraph g) {
		JFileChooser jfc = new JFileChooser(System.getProperty("user.dir"));
		jfc.setFileSelectionMode(JFileChooser.FILES_ONLY);
		jfc.setMultiSelectionEnabled(false);
		if (JFileChooser.APPROVE_OPTION == jfc.showSaveDialog(null)) {
			try {
				java.awt.Color bg = g.getBackground();
				java.awt.image.BufferedImage img = g.getImage(bg, 0);
				javax.imageio.ImageIO.write(img, "JPEG", jfc.getSelectedFile());
			} catch (Exception ex) {
				ex.printStackTrace();
			}
		}
	}

}
